''
{
poweron
start sd
test sd
start sidcog
start input
start random}

CON
   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

   playRate = 50'Hz
  '' SD Configuration
    spiDO     = 16   ''************************************
    spiClk    = 17  ''** This configuration option must **
    spiDI     = 18  ''** be included in your code.      **
    spiCS     = 19  ''************************************

    rightPin = 7
    leftPin  = 6
    ledA =20
    vol  = 0
    btna = 5


  RANGE         = 193            'Range is 0 to RANGE.
  SAMPLES       = 5            'Number of samples to pick: 1 to RANGE + 1

OBJ

  sd     : "fsrwFemto"
  ldr    : "sdspiFemto"      'COG
  sid    : "SIDcog.spin"     'COG
  prng    : "jkiss32"
  RandomNumb : "RealRandom"  'COG
  'OLED  : "uOLED-128-GMD1"
  DELAY : "Clock"
  'debug:"debug_cog"
  SERIAL  : "FullDuplexSerialPlus"
VAR
  long totalfiles
  long ioControl[2]   ''** Variable required for SD Routines **
  byte buff[32]       '' buffer for SD
  byte sidbuffer[25]
  byte numbers[RANGE + 1]
  'byte numbers
  byte filenum,btns,mode,oldfn
  byte btnstack[10]
  'uoled
  long SAddr
  long MAddr
  word Type
  word HW
  word SW
  word DevX
  word DevY
  word SD_Demo
  byte uSD_Sector[512]
PUB Start|x

 dira[btna]:=%0
 dira[leda]:=%1
 'outa[leda..ledc]:=%100
 DELAY.PauseMSec(20)
 oldfn:=0
 'startDisplay
 'press key to begin
 btns:=%1
 repeat
     getbtns
     x++
     !outa[leda]
     DELAY.PauseMSec(200)
 until btns==%0
 outa[leda]:=%0

 mode:=btns
 case mode
    %0:
       repeat 5
         outa[leda]:=1
         DELAY.PauseMSec(200)
         outa[leda]:=0
         DELAY.PauseMSec(100)
       getmount
       outa[leda]:=0
       repeat 5
         outa[leda]:=1
         DELAY.PauseMSec(100)
         outa[leda]:=0
         DELAY.PauseMSec(1000)
       getdir
       repeat 5
         outa[leda]:=1
         DELAY.PauseMSec(700)
         outa[leda]:=0
         DELAY.PauseMSec(50)
       outa[leda]:=1
       repeat
          getrandom
          openFile
          openplaysid

pri startDisplay

  repeat 5
'    !outa[ledb]
    delay.pausemsec(200)
'  OLED.INIT
  repeat 10
'    !outa[ledc]
    delay.pausemsec(200)
  DELAY.PauseSec(2)
'  OLED.BACKGROUND(0,0,0)
'  OLED.FTEXT(0,1, 2, 255,255,255, @blast,0)
'  OLED.FTEXT(0,5, 2, 0,255,255, @itsthe,0)
'  OLED.FTEXT(0,8, 2, 255,15,15, @prAstart,0)
  DELAY.PauseSec(2)

pri getbtns
  btns:=ina[btnA]

pri getmount
'  OLED.Erase
'  OLED.FTEXT(0,1, 2, 255,255,255, @mounting,0)
  sd.start(@ioControl) 'start the SD routines
  sd.mount(spiDO,spiClk,spiDI,spiCS)                    'mount the SD
  DELAY.PauseSec(1)

pri getdir|ok,num,i
  num:=0
'  OLED.FTEXT(0,2, 2, 50,255,255, @reading,0)
  sd.opendir
  repeat
    ok := sd.nextfile(@buff)                             'get file directory
    if ok == 0
      num+=1
  while ok == 0                                          'eof? (end of directory)
  totalfiles:=num
  DELAY.PauseSec(1)
'  OLED.FTEXT(0,3, 2, 50,100,5, @filesN,0)
'  OLED.FTEXT(10,3, 2, 50,100,5, num,1)

pri getrandom|x,i

'  OLED.FTEXT(0,4, 2, 255,55,255, @rngstart,0)
  RandomNumb.start
  prng.start
  prng.seed (RandomNumb.random, RandomNumb.random, RandomNumb.random, RandomNumb.random, RandomNumb.random)   ' Seed the PRNG with real random numbers
  RandomNumb.stop

'  text.color(white)
  fill_array(range,samples,1)
'  text.str(string(cr))
  Repeat x from 0 to 5
 '   text.dec(numbers[x])
    if x < 5
 '     text.str(string(", "))
    filenum:=numbers[x]
  DELAY.PauseSec(1)


'  text.color(red)
'  text.str(string(cr, "* * *  playing last random * * *"))
'  text.str(string(cr, "* * *  "))
'  text.dec(filenum)
'  text.str(string(" = "))

pub OpenFile|i
'  OLED.FTEXT(0,5, 2, 50,55,155, @opening,0)
  sd.opendir
  repeat filenum
     sd.nextfile(@buff)

'  text.str(string(" * * *"))

pri OpenPlaySID|i

'  OLED.FTEXT(0,6, 2, 150,25,25, @plsong,0)
  if oldfn<>0
'    OLED.FTEXT(0,7,2,0,0,0, oldfn,1)
'  OLED.FTEXT(0,7,2,150,25,25, filenum,1)
'  OLED.FTEXT(0,8, 2, 0,0,155, @prAnext,0)
  sd.popen((@buff), "r") ' Open tune
  sid.start(rightPin, leftPin)
  repeat
    !outa[leda]
    getbtns
    waitcnt(cnt + (clkfreq/playRate))   ' Wait one VBL
    sid.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcog
  while sd.pread(@sidbuffer,25) => 0 AND btns==%1' Read 25 bytes from SD card
  sid.stop
  DELAY.PauseMSec(200)
  sd.pclose
  oldfn:=filenum


pri Fill_array(r,s,nums) | x, j

if nums == 1
  repeat x from 1 to r                              'Fill numbers array in order.
    numbers[ x ] := x
  repeat x from 0 to s - 1
    j := (prng.random   >> 1) // (R - x + 1) + x
    s := numbers[ j ]
    bytemove(@numbers[ x + 1 ], @numbers[ x ], j - x)       'Shift the values to make room.
    numbers[ x ] := s






{Pri SHUTDOWN | Temp
  OLED.ERASE
  OLED.BACKGROUND(0,0,0)
  OLED.OPAQUE

  OLED.FTEXT(2,2, 0, 255,255,255, string("Shutdown in:"),0)
  'OLED.FONT_SIZE(2)
  OLED.UCHAR("5", 90,8, 250,250,0, 2,2)

  OLED.FTEXT(3,8, 0, 250,250,0, string("Restart in 5 Sec"),0)
  DELAY.pauseSec(1)
  OLED.UCHAR("4", 90,8, 0,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("3", 90,8, 250,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("2", 90,8, 250,250,0, 2,2)
  DELAY.pauseSec(1)
  OLED.UCHAR("1", 90,8, 250,0,0, 2,2)
  DELAY.PauseSec(1)
  OLED.UCHAR("0", 90,8, 250,0,0, 2,2)
  DELAY.PauseSec(1)

  OLED.ERASE
  DELAY.PauseMSec(20)

  OLED.POWER(0)
  DELAY.PauseSec(4)
  OLED.POWER(1)
  DELAY.PauseMSec(500)
  'OLED.RESET
  OLED.AUTO_BAUD
}
{pub stuff
pub mainmenu|picknum
 btns:=%111
 repeat
    text.cls
    text.color(lred)
    text.center(string("* * * SID PLAYER * * *"))
    text.str(string(CR,CR,"_main menu_",CR,"%011:play random",cr,"%101:show dir",cr,"$110:test menu",CR,"$001: pick file",cr))
    text.color(white)
    text.str(string("buttons:"))
    repeat
      btns:=ina[btnA..btnC]
      text.bin(btns,3)
      waitcnt(clkfreq/20+cnt)
      text.out(bks)
      text.out(bks)
      text.out(bks)
    until btns<>%111

    case btns
      %011:
           text.str(string(13,"play random sid"))
           playrandom
           waitcnt(clkfreq*2+cnt)
      %101:
           text.str(string(13,"show the dir"))
           testdirectory
           waitcnt(clkfreq*2+cnt)
      %110:
           text.str(string(13,"full test menu"))
           testmenu
      %001:
           btns:=%111
           text.str(string(13,"pick file num",13))
           repeat
              btns:=ina[btnA..btnC]
              text.dec(picknum)
              waitcnt(clkfreq/20+cnt)
              if picknum<10
                 text.str(string(" "))
                 text.out(bks)
                 text.out(bks)
              if picknum > 9 and picknum < 100
                 text.str(string(" "))
                 text.out(bks)
                 text.out(bks)
                 text.out(bks)
              if picknum > 99
                 text.out(bks)
                 text.out(bks)
                 text.out(bks)
              if btns==%011
                 if picknum>1
                    picknum--
              if btns==%101
                 if picknum<totalfiles
                    picknum++
           until btns==%110
           text.str(string(13,"you have selected file number "))
           text.dec(picknum)
           text.out(cr)
           text.str(@filename[picknum])
           waitcnt(clkfreq*2+cnt)

pub playrandom
pub testmenu
  btns:=%111
  repeat
    text.cls
    text.color(lred)
    text.center(string("* * * SID PLAYER * * *"))
    text.str(string(CR,CR,"_test menu_",CR,"%011:test sid",cr,"%101:test mount SD",cr,"$110:main menu",CR, "%001:test random"))
    text.color(white)
    text.str(string(cr,"buttons:"))

    repeat
      btns:=ina[btnA..btnC]
      text.bin(btns,3)
      waitcnt(clkfreq/10+cnt)
      text.out(bks)
      text.out(bks)
      text.out(bks)
    until btns<>%111

    case btns
      %011:
           text.str(string(13,"play test sid"))
           testsid
      %101:
           text.str(string(13,"test mount SD"))
           testmountsd
           waitcnt(clkfreq*2+cnt)
      %110:
           text.str(string(13,"back to main menu"))
           mainmenu
      %001:
           text.str(string(13,"testing random"))
           testrandom


  'mode select
    'btnA=rnd
    'btnB=pick
    'btnC=test
  'case mode
    'A ='pick random number
        'directory
        'display file name
        'play sid
        'btnA = pick new sid
        'btnC = stop and go to main
          'close file and sd card
          'return to mode

    'B = load dir
        'display dir
        'pick file num
        'btn A = up
        'btn B = down
        'btn C = select
        'locate file
        'display file name
        'load seleciton and play

                                              




{repeat 'do this forever
  debug.str(string("Choose the test to run",13))
  debug.str(string(" 0: Test Serial            5: Test LEDs",13))
  debug.str(string(" 1: Test SD Mount          6: Test sound",13))
  debug.str(string(" 2: Test SD Directory      7: Test buttons",13))
  debug.str(string(" 3: Test SD Write          8: Test SID",13))
  debug.str(string(" 4: Test SD Read txt file  9: Test PickSid",13))
  debug.str(string("root"))
  waitcnt(clkfreq*1 + cnt)
  debug.str(string(":"))
  testnum:=debug.getdec

  runtest 

  debug.str(string(13,"    ^ ** -- returning to main -- ** ^",13))
  waitcnt(clkfreq/5 + cnt)}


{PUB runtest
                     
case testnum
  0: TestSerial                  '' Uncomment this line to test your communication setup
  1: TestMountSD                 '' Uncomment this line to test your SD setup.
  2: TestDirectory               '' Uncomment this line to display your SD directory
  3: TestWrite                   '' Uncomment this line to write a file to your SD card
  4: TestReadTextFile
  5: TestLEDS
  6: TestSound
  7: TestButtons
  8: TestSid
  9: TestPickSid
  other: debug.str(string("** invalid"))
         return}

PUB TestSid|fn

  sid.start(rightPin, leftPin)          ' Start the emulated SID in a cog
  sd.start(@ioControl)
  sd.mount(spiDO,spiClk,spiDI,spiCS) '' Mount the SD
  sd.popen(string("TITLE_~1.dmp"), "r") ' Open tune
    'Main loop
  repeat
    waitcnt(cnt + (clkfreq/playRate))   ' Wait one VBL
    sd.pread(@sidbuffer,25)                ' Read 25 bytes from SD card
    sid.updateRegisters(@sidbuffer)        ' Write 25 byte to SIDcog
  closesd

PUB TestPickSid|fn,x,r

  sd.start(@ioControl)
  sd.mount(spiDO,spiClk,spiDI,spiCS) '' Mount the SD
  r:=sd.popen(fn, "r") ' Open tune
  case r
        0    : sid.start(rightPin, leftPin)          ' Start the emulated SID in a cog
               repeat until ina[btnA..btnC]<>%111
                  waitcnt(cnt + (clkfreq/playRate))   ' Wait one VBL
                  sd.pread(@sidbuffer,25)                ' Read 25 bytes from SD card
                  sid.updateRegisters(@sidbuffer)' Write 25 byte to SIDcog
               sid.stop
               closesd
               waitcnt(clkfreq*1+cnt)

{PUB TestSerial | counter,x  ''Simple communication test routine

  ''Send messates stored in the DAT block.

  counter := 1
  repeat 2
     Debug.Str(string("This is a line number: "))
     Debug.Dec(counter++)
     Debug.Str(string(13,"PST configuration is working.",13,13))
     waitcnt(clkfreq + cnt)

  Debug.Str(string("      dec  hex   bin",13))
  debug.str(string("value              "))
  repeat x from 0 to 100
    debug.CursorX(6)
    debug.dec(x)
    debug.CursorX(11)
    debug.hex(x,3)
    debug.CursorX(17)
    debug.bin(x, 7)
    waitcnt(clkfreq/8 + cnt)
  check_error(9)}


  
PUB TestMountSD   ''SD Connection Test Routine
  
  sd.start(@ioControl)                                  'start the SD routines

  if \sd.mount(spiDO,spiClk,spiDI,spiCS) < 0          ''    SD Connection Startup
     text.str(string(13,"No SD card present.",13))   ''*****************************
     text.str(string("SD card expected on: P"))      ''** This SD startup routine **
     text.dec(spiDO)                                 ''** provides a gracefull    **
     text.str(string(", P"))                         ''** exit if something is    **
     text.dec(spiClk)                                ''** not connected properly  **
     text.str(string(", P"))                         ''** or if the card is       **
     text.dec(spiDI)                                 ''** unplugged.              **
     text.str(string(", P"))                         ''**                         **
     text.dec(spiCS)                                 ''** Code adapted from:      **
     text.str(string(13,13,"Program halted.",13))    ''** Mike Green              **
     abort                                            ''*****************************
  else
     text.str(string(13,"Connection to SD correctly established..",13))
     sd.unmount

  closesd                                               'Stop the SD Routines

     
{PUB TestWrite | r

  sd.start(@ioControl) '' ** Start the SD Routines **
  
  '' Send a line of text to the SD

  debug.str(string(13,"** Sending information to SD",13))
  sd.mount(spiDO,spiClk,spiDI,spiCS) '' Mount the SD
  sd.popen(string("alpha.txt"),"w")  '' Open alpha.txt for write
  sd.str(string("This is a line of text written to the SD card.",13,10))
  sd.str(string("This is another line of text 1234ABCD test.",13,10))
  closesd
  check_error(9)}

PUB TestDirectory | i, r,num     ''Display the file directory
  num:=0

  sd.start(@ioControl)                                  'start the SD routines
  sd.mount(spiDO,spiClk,spiDI,spiCS)                    'mount the SD
  text.str(string(13,"Reading directory",13))
  r := sd.opendir                                       'open directory
  repeat
    if ina[btnb]==%0
      waitcnt(clkfreq/2+cnt)
    r := sd.nextfile(@buff)                             'get file directory
    if r == 0
      filename[num]:=@@buff
      num+=1
      text.str(string("file#"))
      text.dec(num)
      text.str(string(": "))
      repeat i from 0 to 11                             'display filename
        if buff[i] <> 0
          text.out(buff[i])
      text.out(13)
  while r == 0                                          'eof? (end of directory)
  totalfiles:=num
  text.str(string(13,"done. "))
  text.dec(totalfiles)
  text.str(string(" files found."))
  closesd

pub closesd
  text.str(string("** Closing File"))
  sd.pclose
  text.str(string("** Closed"))
  text.str(string("** Unmounting"))
  sd.unmount                                            'Unmount the SD
  text.str(string("** Unmounted"))
  text.str(string("** Stopping SD"))
  sd.stop
  text.str(string("** SD Stopped"))

{Pub TestReadTextFile|r
  
  sd.start(@ioControl) '' ** Start the SD Routines ** 
  debug.str(string(13,"file name: ",13))
  debug.getstr(@filename) 
  debug.str(string(13,"** opening "))
  debug.str(@filename)
  
  sd.mount(spiDO,spiClk,spiDI,spiCS)                                          '' Mount the SD 
  r := sd.popen(@filename,"r") '' Open alpha.txt for read 
  
  case r
    0: debug.str(string(13,"open success",13))
       repeat until r == -1 '' Start a loop until the end of the file is reached.
         r := sd.pgetc   '' Grap a single character
         if r > 0        '' If character is greater than nothing, display it.
             debug.tx(r)

    OTHER: check_error(3)
  
  sd.unmount '' Unmount the SD
  sd.stop                                               'Stop the SD Routines
  
  check_error(9)}

{Pub TestLEDS   | timeCounter, frequencyCounter, brightCounter, stp,rpeats,lstarttemp,rcount

  timeCounter := ((clkfreq / 5000) * _timeStepInMilliseconds)
  debug.str(string("enter led start: "))
  lstarttemp:=ledstart:=debug.getdec
  debug.str(string("enter led end: "))
  ledend:=debug.getdec
  debug.str(string("enter led step(1): "))
  stp:=debug.getdec
  debug.str(string("enter repeats: "))
  rpeats:=debug.getdec
  rcount:=0
  debug.str(string("** leds under test",13))

  repeat rpeats
   rcount+=1
   debug.str(string(13,"test num: "))
   debug.dec(rcount)
   ledstart:=lstarttemp
   repeat until ledstart>ledend
    repeat brightCounter from 10 to 100 step stp
        led.LEDBrightness(brightCounter, ledstart)
        waitcnt(timeCounter + cnt) 

    repeat brightCounter from 99 to 10 step stp
        led.LEDBrightness(brightCounter, ledstart)
        waitcnt(timeCounter + cnt)
    
    repeat frequencyCounter from 0 to 30 step stp
        led.LEDFrequency(frequencyCounter, ledstart)
        waitcnt(timeCounter + cnt)
      
    repeat frequencyCounter from 30 to 0 step stp
        led.LEDFrequency(frequencyCounter, ledstart)
        waitcnt(timeCounter + cnt)  
    led.LEDBrightness(0, ledstart)
    ledstart++
  
  check_error(9)
}
{Pub TestSound | volume, tests, _speakerFrequencyMsPauseTime,_speakerMaxFrequency,_speakerMinFrequency,_speakerFrequencyStep

{  tests := 5
  volume := 10
  _speakerMaxFrequency := 1000
  _speakerMinFrequency := 10
  _speakerFrequencyStep := 10
  _speakerFrequencyMsPauseTime := 10      }
     

  debug.str(string(13,"volume 0-50(10)",13))
  volume:=debug.getdec

  debug.str(string(13,"# of tests(5)",13))
  tests:=debug.getdec

  debug.str(string(13,"min freq(10)",13))
  _speakerMinFrequency:=debug.getdec

  debug.str(string(13,"max freq(1000)" ,13))
  _speakerMaxFrequency:=debug.getdec

  debug.str(string(13,"freq step(10)",13))
  _speakerFrequencyStep:=debug.getdec

  debug.str(string(13,"freq pause time(10)",13))
  _speakerFrequencyMsPauseTime:=debug.getdec

  spk.SPKEngineStart(_speakerPin)
  
  spk.changeSpeakerVolume(volume) 

  repeat tests
   
    repeat result from _speakerMinFrequency to _speakerMaxFrequency step _speakerFrequencyStep
      spk.changeSpeakerFrequency(result)
      waitcnt(((clkfreq / 1000) * _speakerFrequencyMsPauseTime) + cnt)

    repeat result from _speakerMaxFrequency to _speakerMinFrequency step _speakerFrequencyStep
      spk.changeSpeakerFrequency(result)
      waitcnt(((clkfreq / 1000) * _speakerFrequencyMsPauseTime) + cnt)

  spk.SPKEngineStop
  waitcnt(clkfreq/10+cnt)
  check_error(9)
Pub TestButtons|times,num,leds,x

  debug.str(string(13,"repeats 0-5000",13))
  times:=debug.getdec
  num:=0
  waitcnt(clkfreq/10 + cnt)
   repeat times
    leds:= btns := !ina[nxxt..play]                    ' Copy P21 input to P6 ouput
    outa[leda..ledc]:=leds
    debug.str(string(13,"btnstest"))
    debug.dec(num)
    debug.str(string(":%"))
    debug.bin(btns,3)
    num++
    debug.cursorup
    debug.CursorX(x)
    waitcnt(clkfreq/100 + cnt)
   outa[leda..ledc]:=0

}
pub testrandom|i

 btns:=%111
 repeat while ina[btna]==%111
  fill_array(range,samples,1)
  text.dec(numbers[i])   'ssssssssssssssssssssssssssssssssssssssssssssssssss
  text.out(cr)
  waitcnt(clkfreq/20+cnt)

.}




dat
blast byte "A blast from the past...",0
itsthe byte "its the           c64 SidPlayer!",0
prAstart byte "press btnA       to start",0
prAnext byte "press btnA for      next song",0
mounting byte "* mounting card",0
testfile byte "for_away.dmp",0
reading byte "* reading dir",0
filesN byte "* files: ",0
rngstart byte "* starting rng",0
opening byte "* opening file",0
plsong byte "* playing song",0
blank byte " ",0
